Subject: Re: SCTP performance?

From: Vlad Yasevich <[email-masked]>
Date: Mon, 12 Aug 2013 16:10:39 -0400

On 08/09/2013 08:04 PM, Ben Greear wrote:
> On 08/09/2013 04:21 PM, Eric Dumazet wrote:
>> On Fri, 2013-08-09 at 16:11 -0700, Ben Greear wrote:
>>> I just added some support for SCTP to my traffic-generator tool.
>>>
>>> I tried to send 1Gbps of traffic, bi-directional, across two
>>> 10G interfaces.  TCP does this without any trouble at all,
>>> but SCTP was asymetric and never got above around 700Mbps,
>>> and was usually stuck at < 500Mbps.
>>>
>>> perf top didn't show any obvious CPU bottlenecks.
>>>
>>> Has anyone done any recent performance testing with SCTP?
>>>
>>> I'd be interested to know the results if so...
>>
>> You mean there is no SCTP offload on the NIC and/or GRO, yes that's too
>> bad.
>>
>
> I'm sure that is part of the problem.
>
> I got much better results when I explicitly set the
> tx/rx socket buffer sizes to 2MB, so maybe it just sucks
> at auto-tuning it's socket buffer sizes.
>
> Thanks,
> Ben
>

There is no buffer autotunning.  There is also no GRO since SCTP doesn't
lend itself easily to GRO. :(

There has been some research efforts at autotunning, but nothing 
proposed.  I'll see if I can find the code and make it work better.

-vlad